

* _ZADAJ_PERIOD.PRG
// 20-04-2008 COBA Systems  Stanojevi S.











******************************************************************************************************
* Clipper Summer 87'
* ZADAVANJE PERIODA od DATUM1 do DATUM2
* Na pocetku programa postavi zadavanje perioda u datumima:
*
* IF Per_3D() = .F.
*     RETURN NIL  // prekini izvrsenje programa
* ELSE
*     // generisi izvestaj od PUBLIC: DATUM1 do DATUM2
* ENDIF




******************************************************************************************************
FUNCTION Per_3D
******************************************************************************************************
* --
* -- ZADAVANJE PERIODA od DATUM1 do DATUM2 ZA:
* -- Pretrazivanje i vadjenje izvestaja "Od Datuma do Datuma"
* -- Formira PUBLIC promenljive DATUM1, DATUM2, DATUM3 cim
* -- se startuje Per_Per() funkcija
* --
SET DATE GERMAN
SET CENTURY ON
PRIVATE boja,prozor,vrati
save screen to prozor
vrati=.F.

************************************
 * Ucitaj public datume:
 aq = Per_per(1,0)

        *  DATUM1=DATE()
        *  DATUM2=DATE()
        *  DATUM3=DATE()
************************************
DSTART=SPACE(15)
************************************

*************
DO WHILE .T.
*************
boja=SETCOLOR()
SET CURSOR ON
SET COLOR TO W+/B
@ 07,25 CLEAR TO 13,54
@ 07,25 TO 13,54 DOUBLE
@ 08,29 SAY "PERIOD:"
@ 10,29 SAY "OD DATUMA " GET DATUM1
@ 12,29 SAY "DO DATUMA " GET DATUM2
READ
CLEAR GETS
SETCOLOR(boja)

  IF LASTKEY()=27
    vrati=.F.
    EXIT
  ENDIF

  IF DATUM2<DATUM1
     msgbox("Drugi datum mora biti jednak ili veci od prvog datuma","STOP")
     LOOP
  ENDIF
  **********************************
       * Upisi public datume datume
         aq=Per_Per(1,1)
  **********************************
  vrati=.T.
  EXIT

ENDDO

SETCOLOR(boja)
restore screen from prozor
release prozor
RETURN(vrati)






* --
* -- Cuvanje datuma perioda, kako se ne bi stalno upisivali u MODUL za
* -- Zadavanje perioda od datuma do datuma: * ODOD * kao i svi drugi moduli,
* -- u ostalim programima koji koriste period.
* --
* -- Sintaksa:
* -- Per_Per(podrucje,CitajPisi)->0
* -- podrucje............. SELECT podrucje rada PERIOD.DBF fajla
* -- CitajPisi............ 0=citanje DATUM1,DATUM2,DSTART
* -- CitajPisi............ 1=upis    DATUM1,DATUM2,DSTART
* --
 ******************
 FUNCTION Per_Per
 ******************
 PARAMETERS podrucje,CitajPisi
 *****************************
 SET DATE GERMAN
 SET CENTURY ON
 PUBLIC DATUM1,DATUM2,DATUM3
 *****************************
 PRIVATE radno
 radno=SELECT()
 SELECT(podrucje)
 * --
 * -- Proveri ima li fajla, ako ga nema napravi ga:
 * --
 IF .NOT. FILE("GKPERIOD.DBF")
 *------------------------------------------------------------------------

  CREATE pom2D.dbf

  USE pom2D.dbf
  append blank
  REPLACE field_name WITH 'DATUM1_   ',field_type WITH 'D',field_len  WITH    8 ,field_dec  WITH    0
  append blank
  REPLACE field_name WITH 'DATUM2_   ',field_type WITH 'D',field_len  WITH    8 ,field_dec  WITH    0
  append blank
  REPLACE field_name WITH 'DATUM3_   ',field_type WITH 'D',field_len  WITH    8 ,field_dec  WITH    0
  append blank
  REPLACE field_name WITH 'FOLDER_   ',field_type WITH 'C',field_len  WITH   31 ,field_dec  WITH    0
  append blank
  REPLACE field_name WITH 'FOLDE1_   ',field_type WITH 'C',field_len  WITH   31 ,field_dec  WITH    0
  append blank
  REPLACE field_name WITH 'FOLDE2_   ',field_type WITH 'C',field_len  WITH   31 ,field_dec  WITH    0
  USE
  CREATE GKPERIOD.DBF FROM pom2D.dbf
  DELETE FILE pom2D.dbf
  USE

  USE GKPERIOD.DBF NEW EXCLUSIVE
  //USE GKPERIOD.DBF
   APPEND BLANK
   REPLACE DATUM1_ WITH DATE(), DATUM2_ WITH DATE(), DATUM3_ WITH DATE()
   REPLACE FOLDER_ WITH "A"
   REPLACE FOLDE1_ WITH "C:\COBA2000\FIRME\FIRMA-01\2001"
   REPLACE FOLDE2_ WITH "D:\COBA2000\FIRME\FIRMA-01\2001"
  USE
  COMMIT


 *------------------------------------------------------------------------
 ENDIF  && IF .NOT. FILE("GKPERIOD.DBF")



  USE GKPERIOD.DBF NEW EXCLUSIVE
  IF NetErr()
   MsgBox("DATUM1 - DATUM2","STOP1")
   SELECT(radno)
   RETURN(0)
  ENDIF
 * --
 * -- Posto sad ima fajla, ucitaj datume iz njega:
 * --
   IF CitajPisi=0
      //USE GKPERIOD.DBF
      GO TOP
      DATUM1=DATUM1_
      DATUM2=DATUM2_
      DATUM3=DATUM3_
      USE
   ENDIF
 * --
 * -- Posto sad ima fajla, upisi datume u njega:
 * --
   IF CitajPisi=1
      //USE GKPERIOD.DBF
      GO TOP
      REPLACE DATUM1_ WITH DATUM1, DATUM2_ WITH DATUM2
      * Ovaj se upisuje samo rucno i direktno: DATUM3_ WITH DATUM3
      USE
   ENDIF
 SELECT(radno)
 RETURN(0)












***********************************************************************************************************

* ALASKA Xbase++
* GUI DIALOG ZA PERIOD OD 2 DATUMA (3 DATUMA) PERIOD3D.PRG *

/*  PRIMENA:

  Per_3D()             // promeni period, ili...

  IF Per__Per(1,0) = 1  // procitaj period i prihvati ga ili odustani
     MsgBox("FORMIRANJE IZVESTAJA","NASTAVI PROGRAM")
  ELSE
     MsgBox("IZLAZ IZ PROGRAMA","STOP")
  ENDIF


  xDatum() // upis jednog datuma

*/




*  FUNCTION Per__3D()                          // upis perioda od datuma do datuma
*  FUNCTION xPer__Per( podrucje,CitajPisi )     // ucitavanje perioda od datuma do datuma
* -- Sintaksa:
* -- Per__Per(podrucje,CitajPisi)->0
* -- podrucje............. SELECT podrucje rada PERIOD.DBF fajla
* -- CitajPisi............ 0=citanje DATUM1,DATUM2,DSTART
* -- CitajPisi............ 1=upis    DATUM1,DATUM2,DSTART
* --

//---------------------------------------------------------------------------------------------------------
// 1.
// ALASKA GUI DIALOG ZA UPIS PERIODA IZMEU DVA DATUMA SA KONTROLOM DATUMA I HELP TEKSTOM
* FUNCTION Per__3D( prozor, cNaslov, lKontrola, cHlpTxt )                    // zadaj dva datuma
* FUNCTION xPeriod( dDatum1, dDatum2, prozor, cNaslov, lKontrola, cHlpTxt ) // zadaj dva datuma
* STATIC FUNCTION izlaz_na_OK(dDatum1,dDatum2,oID,oPW,lKontrola)// izlaz sa izmenom
* FUNCTION xPer__Per( podrucje,CitajPisi )                       // Cuvanje datuma perioda u GKPERIOD.DBF
                                                                // ucitavanje perioda od datuma do datuma
* STATIC FUNCTION CenterPos( aSize, aRefSize )
//---------------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------------
// 2.
// ALASKA GUI DIALOG ZA UPIS JEDNOG DATUMA SA KONTROLOM DATUMA I HELP TEKSTOM
* FUNCTION xDatum( dDatum1, cNaslov, lKontrola, cHlpTxt, prozor )
* STATIC FUNCTION izlaz_sa_OK(dDatum1, oID, lKontrola)          // izlaz sa izmenom
* STATIC FUNCTION Uputstvo_xDatum(cHlpTxt,oXbp)
* FUNCTION Kontrola_Datuma(DT)
//---------------------------------------------------------------------------------------------------------


***********************************************************************************************************



#include "Gra.ch"
#include "Xbp.ch"
#include "font.ch"
#include "setcurs.ch"
#include "Appevent.ch"
#include "Common.ch"


***********************************************************************************************************
// ALASKA GUI DIALOG ZA UPIS PERIODA IZMEU DVA DATUMA SA KONTROLOM DATUMA I HELP TEKSTOM
FUNCTION Per__3D( prozor, cNaslov, lKontrola, cHlpTxt )
***********************************************************************************************************
/*
 PARAMETRI ZA GUI-DIALOG
 prozor je oDLg objekat prema kome je ovaj prozor modalan
 cNaslov je naslov ovog prozora
 lKontrola odredjuje da li se kontrolise ispravnost upisanog datuma
 cHlptxt je tekst koji se pojavljuje u helpu
*/
*
* // ZADAVANJE PERIODA od DATUM1 do DATUM2
*
   LOCAL dDatum1,dDatum2,DSTART,txt, radno := SELECT()
   LOCAL nEvent, mp1, mp2, oXbp

            set charset to ansi
            set date german
            set century on


   ************************************
   * //Ucitaj datume iz GKPERIOD.DBF
    aq = xPer__per(1,2)

           *  DATUM1=DATE()
           *  DATUM2=DATE()
           *  DATUM3=DATE()

              DSTART=SPACE(15)
   ************************************

   dDatum1   := DATUM1    // puni se iz funkcije xPeriod()
   dDatum2   := DATUM2    // puni se iz funkcije xPeriod()

   IF empty(dDatum1)
      dDatum1   := date()
   ENDIF
   IF empty(dDatum2)
      dDatum2   := date()
   ENDIF



  DO WHILE .T.

  *********************************************************************
   xPeriod( @dDatum1, @dDatum2, prozor, cNaslov, lKontrola, cHlpTxt  )        // GUI dialog
  *********************************************************************

   IF empty(dDatum1)
      dDatum1   := date()
      MsgBox("Mora se ISPRAVNO upisati prvi datum","GREKA")
      LOOP
   ENDIF
   IF empty(dDatum2)
      dDatum2   := date()
      MsgBox("Mora se ISPRAVNO upisati drugi datum","GREKA")
      LOOP
   ENDIF


   IF dDatum1 > dDatum2
      MsgBox( "Prvi Datum ne moe biti veci od drugog","GREKA" )
      LOOP
   ENDIF



      **********************************
      * // Upisi datume u GKPERIOD.DBF
          DATUM1 := dDatum1
          DATUM2 := dDatum2
          //msgbox(dtoc(DATUM1)+" "+DTOC(DATUM2))
          aq=xPer__Per(1,1)
      **********************************

   vrati=.T.
   EXIT

  ENDDO

SELECT(radno)

RETURN(0)




***********************************************************************************************************
FUNCTION xPeriod( dDatum1, dDatum2, prozor, cNaslov, lKontrola, cHlpTxt )   // zadaj dva datuma
***********************************************************************************************************
/*
 PARAMETRI ZA GUI-DIALOG
 prozor je oDLg objekat prema kome je ovaj prozor modalan
 cNaslov je naslov ovog prozora
 lKontrola odredjuje da li se kontrolise ispravnost upisanog datuma
 cHlptxt je tekst koji se pojavljuje u helpu
*/

   LOCAL nEvent, mp1, mp2, oXbp, lExit
   LOCAL oDlg, oID, oPW, drawingArea
   LOCAL dt1, dt2, txt
   LOCAL aDatumi := {dDatum1,dDatum2}

            set charset to ansi
            set date german
            set century on
            dt1 := dtoc(dDatum1)
            dt2 := dtoc(dDatum2)

   txt := "KOMANDE ZA UPIS PERIODA"     +chr(13)+chr(10)+;
          " "                                               +chr(13)+chr(10)+;
          "Da bi se upisao ili izmenio bilo koji znak,"     +chr(13)+chr(10)+;
          "prethodno ga treba obrisati tasterom (Delete)."  +chr(13)+chr(10)+;
          "Brisanjem svih znakova, sa dugmetom (Brii),"    +chr(13)+chr(10)+;
          "dozvoljava se nesmetan novi upis svih znakova."  +chr(13)+chr(10)+;
          " "                                               +chr(13)+chr(10)+;
          "Sa dugmetom (OK) pa tasterom (Enter) daje se"    +chr(13)+chr(10)+;
          "potvrda za prihvatanje upisanog podatka i izlaz."+chr(13)+chr(10)+;
          " "                                               +chr(13)+chr(10)+;
          "Taster (Esc) je izlaz bez prihvatanja izmena."   +chr(13)+chr(10)+;
          " "                                               +chr(13)+chr(10)+;
          "Strelica dole i gore za izbor dugmadi i polja"   +chr(13)+chr(10)+;
          "za upis podatka."



   DEFAULT prozor    TO SetAppWindow(),;
           cNaslov   TO   "Period od datuma do datuma:" ,;
           lKontrola TO .F. ,;
           cHlpTxt   TO txt


   aSize            := {250,150}
   aPos             := CenterPos( aSize, SetAppWindow():currentSize() )
   mp1              := SetAppWindow():currentPos()

   aPos[1]          += mp1[1]
   aPos[2]          += mp1[2]

  /*
   * Parent is desktop, owner is application window
   */
     oDlg             := XbpDialog():new( SetAppWindow():setParent(), SetAppWindow(), aPos, aSize, , .F.)
*    oDlg             := XbpDialog():new( prozor:setParent(), prozor, aPos, aSize, , .F.)
   oDlg:border      := XBPDLG_RAISEDBORDERTHIN_FIXED
   oDlg:title       := cNaslov
   oDlg:taskList    := .T.
   oDlg:sysMenu     := .F.
   //oDlg:maxButton   := .F.
   //oDlg:minButton   := .F.
   oDlg:close       :=  {|| PostAppEvent( xbeP_Close ) }
   oDlg:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_ESC , ; // IZLAZ BEZ IZMENE aDatum1, aDatum2
                                     lExit := .T., NIL ) }
   oDlg:create()
   //oDlg:setFontCompoundName( FONT_HELV_SMALL + FONT_STYLE_BOLD )
   drawingArea      := oDlg:drawingArea

   oXbp             := XbpStatic():new( drawingArea, , {8,84}, {80,20} )
   oXbp:caption     := "od datuma:"
   oXbp:options     := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   oXbp:setFontCompoundName( "8.Arial Bold" )

   oID              := XbpSLE():new( drawingArea, , {101,83}, {116,22} )
   oID:group        := XBP_BEGIN_GROUP
   oID:tabStop      := .T.
   oID:bufferLength := 10 // dDatum1 // Len( DTOC(dDatum1) )
   oID:create()
   oID:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_F1,  Uputstvo_xDatum(cHlpTxt,oID), NIL ) }  // (F1) ZA HELP SAMO IZ POLJA ZA UPIS
   oID:setData(dt1)
   oID:setFontCompoundName( FONT_COURIER_MEDIUM + FONT_STYLE_BOLD )

   oXbp             := XbpStatic():new( drawingArea, , {8,52}, {80,20} )
   oXbp:caption     := "do datuma:"
   oXbp:options     := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   oXbp:setFontCompoundName( "8.Arial Bold" )

   oPW              := XbpSLE():new( drawingArea, , {101,51}, {116,22} )
   oPW:group        := XBP_WITHIN_GROUP
   oPW:tabStop      := .T.
   oPW:bufferLength := 10 // dDatum1 // Len( DTOC(dDatum2) )
   oPW:create()
   oPW:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_F1,  Uputstvo_xDatum(cHlpTxt,oPW), NIL ) }  // (F1) ZA HELP SAMO IZ POLJA ZA UPIS
   oPW:setData(dt2)
   oPW:setFontCompoundName( FONT_COURIER_MEDIUM + FONT_STYLE_BOLD )



// --------------------- dugmad ----------------------------------------------------------------------------



   oXbp             := XbpPushButton():new( drawingArea, , {10,11}, {60,25} )
   oXbp:caption     := "OK"   // izlaz sa prihvatanjem izmenjenog podatka
   oXbp:tabStop     := .T.
   oXbp:preselect   := .T.
   oXbp:group       := XBP_WITHIN_GROUP
   oXbp:activate    := {|| aDatumi := Izlaz_na_OK(dDatum1,dDatum2,oID,oPW,lKontrola), lExit := .T. } // IZLAZ SA IZMENOM
   oXbp:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_RETURN,; // (RETURN) ZA START DUGMETA SAMO IZ DUGMETA
                                     PostAppEvent( xbeP_Activate,,, obj ), NIL ) }
   oXbp:create()
   oXbp:setpointer(nil,2)

   oXbp             := XbpPushButton():new( drawingArea, , {72,11}, {60,25} )
   oXbp:caption     := "Brii"
   oXbp:tabStop     := .T.
   oXbp:preselect   := .T.
   oXbp:group       := XBP_WITHIN_GROUP
   oXbp:activate    := {|| oID:clear(),oPW:clear(), SetAppFocus(oID),tone(500,1) }
   oXbp:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_RETURN, PostAppEvent( xbeP_Activate,,, obj ), NIL ) } // (RETURN) ZA START DUGMETA SAMO IZ DUGMETA
   oXbp:create()
   oXbp:setpointer(nil,2)

   oXbp             := XbpPushButton():new( drawingArea, , {204,11}, {30,25} )
   oXbp:caption     := "?"
   oXbp:tabStop     := .T.
   oXbp:preselect   := .T.
   oXbp:group       := XBP_END_GROUP
   oXbp:activate    := {|| Uputstvo_xDatum(cHlpTxt,oXbp) }
   oXbp:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_RETURN, PostAppEvent( xbeP_Activate,,, obj ), NIL ) } // (RETURN) ZA START DUGMETA SAMO IZ DUGMETA
   oXbp:create()
   oXbp:setpointer(nil,2)

   oXbp:setFontCompoundName( FONT_COURIER_MEDIUM + FONT_STYLE_BOLD )
// --------------------- dugmad ----------------------------------------------------------------------------

   oDlg:show()
  /*
   * This makes the login window modal
   */
   //SetAppWindow():disable() // prozor:disable()
   SetAppFocus( oID )

   lExit := .F.
   DO WHILE ! lExit
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
 *************************************************************
   // NOVA VREDNOST ZA datume:
   // aDatumi{} se formira kao nov podatak samo sa OK dugmetom
   dDatum1   := aDatumi[1]
   dDatum2   := aDatumi[2]

   //dDatum1   := CTOD(AllTrim( Upper( oID:getData() ) ))
   //dDatum2   := CTOD(AllTrim( Upper( oPW:getData() ) ))
   //tip = VALTYPE(dD1)
   //msgbox(tip)= "D" date

 *************************************************************
   //SetAppWindow():enable() // prozor:enable()
   oDlg:destroy()

  /*
   * Clean up event queue
   */
   CLEAR TYPEAHEAD
RETURN(0)





**************************************************************
STATIC FUNCTION izlaz_na_OK(dDatum1,dDatum2,oID,oPW,lKontrola)          // izlaz sa izmenom
**************************************************************
 // primljeni postojeci datumi = ddatum1,dDatum2
 // novi upisani datumi = dDatum_1,dDatum_2
   LOCAL dDatum_1   := CTOD(AllTrim( Upper( oID:getData() ) ))
   LOCAL dDatum_2   := CTOD(AllTrim( Upper( oPW:getData() ) ))
   LOCAL aDatumi    := {dDatum_1,dDatum_2}

   IF lKontrola = .T.                 // Kad je ukljucena kontrola datuma
   IF Kontrola_Datuma(dDatum_1) = .F. // prema podacima iz XCoba.SYS: Godina_Rada, Godina_Stop, Datumi_Stop
      dDatum_1 := dDatum1             // ako je novoupisani datum nedozvoljen, vrati primljeni datum
   ENDIF                              // ako je novoupisani datum dozvoljen vrati taj datum

   IF Kontrola_Datuma(dDatum_2) = .F. // prema podacima iz XCoba.SYS: Godina_Rada, Godina_Stop, Datumi_Stop
      dDatum_2 := dDatum2             // ako je novoupisani datum nedozvoljen, vrati primljeni datum
   ENDIF                              // ako je novoupisani datum dozvoljen vrati taj datum
   ENDIF

   aDatumi    := {dDatum_1,dDatum_2}
   Tone(300,1)
RETURN(aDatumi)

/*
 * Calculate the center position for a window from its size and a
 * reference size.
 */
STATIC FUNCTION CenterPos( aSize, aRefSize )
RETURN { Int( (aRefSize[1] - aSize[1]) / 2 ) ;
       , Int( (aRefSize[2] - aSize[2]) / 2 ) }




/*
* --
* -- Cuvanje datuma perioda, kako se ne bi stalno upisivali u MODUL za
* -- Zadavanje perioda od datuma do datuma: * ODOD * kao i svi drugi moduli,
* -- u ostalim programima koji koriste period.
* --
* -- Sintaksa:
* -- Per__Per(podrucje,CitajPisi)->0
* -- podrucje............. SELECT podrucje rada PERIOD.DBF fajla
* -- CitajPisi............ 0=citanje DATUM1,DATUM2,DSTART
* -- CitajPisi............ 1=upis    DATUM1,DATUM2,DSTART
* --
*/
 *******************************************************************************************************
 FUNCTION xPer__Per( podrucje,CitajPisi )  // Cuvanje datuma perioda u GKPERIOD.DBF
 *******************************************************************************************************
 // PARAMETERS podrucje,CitajPisi
 LOCAL radno := SELECT()
 *****************************
 SET DATE GERMAN
 SET CENTURY ON
 PUBLIC DATUM1,DATUM2,DATUM3
 *****************************


 * --
 * -- Proveri ima li fajla, ako ga nema napravi ga:
 * --
 IF .NOT. FILE("GKPERIOD.DBF")
 *------------------------------------------------------------------------
  SELECT (0)  // prvo slobodno podrucje
  cFajl := "pomocna"
  CREATE (cFajl)

  USE (cFajl) EXCLUSIVE
  IF NetErr()
   MsgBox("= PERIOD-DATUM1-DATUM2 =","STOP mrea")
   SELECT(radno)
   RETURN(0)
  ENDIF

  append blank
  REPLACE field_name WITH 'DATUM1_   ',field_type WITH 'D',field_len  WITH    8 ,field_dec  WITH    0
  append blank
  REPLACE field_name WITH 'DATUM2_   ',field_type WITH 'D',field_len  WITH    8 ,field_dec  WITH    0
  append blank
  REPLACE field_name WITH 'DATUM3_   ',field_type WITH 'D',field_len  WITH    8 ,field_dec  WITH    0
  append blank
  REPLACE field_name WITH 'FOLDER_   ',field_type WITH 'C',field_len  WITH   31 ,field_dec  WITH    0
  append blank
  REPLACE field_name WITH 'FOLDE1_   ',field_type WITH 'C',field_len  WITH   31 ,field_dec  WITH    0
  append blank
  REPLACE field_name WITH 'FOLDE2_   ',field_type WITH 'C',field_len  WITH   31 ,field_dec  WITH    0
  USE
  CREATE GKPERIOD.DBF FROM (cFajl)
  DELETE FILE (cFajl)
 *
  USE GKPERIOD.DBF EXCLUSIVE
  IF NetErr()
   MsgBox("= PERIOD-DATUM1-DATUM2 =","STOP mrea")
   SELECT(radno)
   RETURN(0)
  ENDIF

  //USE GKPERIOD.DBF
   APPEND BLANK
   REPLACE DATUM1_ WITH DATE(), DATUM2_ WITH DATE(), DATUM3_ WITH DATE()
   REPLACE FOLDER_ WITH "A"
   REPLACE FOLDE1_ WITH "C:\COBA2000\FIRME\FIRMA-01\2001"
   REPLACE FOLDE2_ WITH "D:\COBA2000\FIRME\FIRMA-01\2001"
  USE
  COMMIT

  SELECT(radno)
 *------------------------------------------------------------------------
 ENDIF  && IF .NOT. FILE("GKPERIOD.DBF")

  USE GKPERIOD.DBF NEW EXCLUSIVE
  IF NetErr()
   MsgBox("= DATUM1 - DATUM2 =","STOP mrea")
   SELECT(radno)
   RETURN(0)
  ENDIF

 * --
 * -- Posto sad ima fajla, upisi datume u njega:
 * --
   IF CitajPisi=1   // poziva se iskljucivo iz Per_3d()
      //USE GKPERIOD.DBF
      GO TOP
      REPLACE DATUM1_ WITH DATUM1, DATUM2_ WITH DATUM2
      * Ovaj se upisuje samo rucno i direktno: DATUM3_ WITH DATUM3
      USE
   ENDIF
 * --
 * -- Posto sad ima fajla, ucitaj datume iz njega:
 * --
   IF CitajPisi=2    // poziva se iskljucivo iz Per_3d() - ne prikazuje MsgBox() poruku
      //USE GKPERIOD.DBF
      GO TOP
      DATUM1=DATUM1_
      DATUM2=DATUM2_
      DATUM3=DATUM3_
      USE
   ENDIF
 * --
 * -- Posto sad ima fajla, ucitaj datume iz njega:
 * --
   IF CitajPisi=0    // kada se poziva pred izvrsenje izvestaja - prikazuje MsgBox() poruku
      //USE GKPERIOD.DBF
      GO TOP
      DATUM1=DATUM1_
      DATUM2=DATUM2_
      DATUM3=DATUM3_
      USE
      * MsgBox(DTOC(DATUM1)+" - "+DTOC(DATUM2),"PODACI ZA PERIOD")

      IF  ConfirmBox(,"Podaci su za period:"+CHR(13)+CHR(10)+;
                      DTOC(DATUM1)+" - "+DTOC(DATUM2)+CHR(13)+CHR(10)+;
                      "Formiraj...","PERIOD",XBPMB_YESNO) = XBPMB_RET_YES
              SELECT(radno)
              RETURN(1)
      ENDIF
   ENDIF

 SELECT(radno)
 RETURN(0)












//---------------------------------------------------------------------------------------------------------
// ALASKA GUI DIALOG ZA UPIS JEDNOG DATUMA SA KONTROLOM DATUMA I HELP TEKSTOM
* FUNCTION xDatum( dDatum1, cNaslov, lKontrola, cHlpTxt, prozor )
* STATIC FUNCTION izlaz_sa_OK(dDatum1, oID, lKontrola)          // izlaz sa izmenom
* STATIC FUNCTION Uputstvo_xDatum(cHlpTxt,oXbp)
* FUNCTION Kontrola_Datuma(DT)
//---------------------------------------------------------------------------------------------------------

#include "Appevent.ch"
#include "Common.ch"
#include "inkey.ch"
#include "set.ch"
***********************************************************************************************************
// ALASKA GUI DIALOG ZA UPIS JEDNOG DATUMA SA KONTROLOM DATUMA I HELP TEKSTOM
FUNCTION xDatum( dDatum1, cNaslov, lKontrola, cHlpTxt, prozor )    // prozor := setAppWindow()
***********************************************************************************************************
   LOCAL nEvent, mp1, mp2, oXbp, lExit
   LOCAL oDlg, oID, oPW, drawingArea
   LOCAL dt1, dt2, dDatum, txt

   txt := "KOMANDE ZA UPIS DATUMA"                    +chr(13)+chr(10)+;
          " "                                               +chr(13)+chr(10)+;
          "Da bi se upisao ili izmenio bilo koji znak,"     +chr(13)+chr(10)+;
          "prethodno ga treba obrisati tasterom (Delete)."  +chr(13)+chr(10)+;
          "Brisanjem svih znakova, sa dugmetom (Brii),"    +chr(13)+chr(10)+;
          "dozvoljava se nesmetan novi upis svih znakova."  +chr(13)+chr(10)+;
          " "                                               +chr(13)+chr(10)+;
          "Sa dugmetom (OK) pa tasterom (Enter) daje se"    +chr(13)+chr(10)+;
          "potvrda za prihvatanje upisanog podatka i izlaz."+chr(13)+chr(10)+;
          " "                                               +chr(13)+chr(10)+;
          "Taster (Esc) je izlaz bez prihvatanja izmena."   +chr(13)+chr(10)+;
          " "                                               +chr(13)+chr(10)+;
          "Strelica dole i gore za izbor dugmadi i polja"   +chr(13)+chr(10)+;
          "za upis podatka."

            set charset to ansi
            set date german
            set century on


   DEFAULT dDatum1   TO CTOD("  .  .    "),;
           cNaslov   TO "Upis datuma:", ;
           lKontrola TO .T.,;
           cHlpTxt   TO txt,;
           prozor    TO SetAppWindow()

          ****************************************************************
            dDatum := dDatum1 // inicijalno izlazni datum = ulazni datum
          ****************************************************************
            IF EMPTY(dDatum1)
                dt1 := ""
            ELSE
                dt1 := dtoc(dDatum1)
            ENDIF

   aSize            := {200,110}
   aPos             := CenterPos( aSize, SetAppWindow():currentSize() )
   mp1              := SetAppWindow():currentPos()

   aPos[1]          += mp1[1]
   aPos[2]          += mp1[2]

  /*
   * Parent is desktop, owner is application window
   */
     oDlg             := XbpDialog():new( SetAppWindow():setParent(), SetAppWindow(), aPos, aSize, , .F.)
*    oDlg             := XbpDialog():new( prozor:setParent(), prozor, aPos, aSize, , .F.)
   oDlg:border      := XBPDLG_RAISEDBORDERTHIN_FIXED
   oDlg:title       := cNaslov
   oDlg:taskList    := .T.
   oDlg:sysMenu     := .F.
*   oDlg:maxButton   := .F.
*   oDlg:minButton   := .F.
   oDlg:close       := {|| PostAppEvent( xbeP_Close ) }  // IZLAZ BEZ IZMENE
   oDlg:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_ESC ,; // (ESC) ZA IZLAZ IZ PROGRAMA IZ BILO KOG OBJEKTA
                                     lExit := .T., NIL ) }    // dDatum := dDatum1
                                                              // inicijalno izlazni datum = ulazni datum
   oDlg:create()
   //oDlg:setFontCompoundName( FONT_HELV_SMALL + FONT_STYLE_BOLD )
   drawingArea      := oDlg:drawingArea


   oXbp             := XbpStatic():new( drawingArea, , {4,46}, {50,20} )
   oXbp:caption     := "Datum:"
   oXbp:options     := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   oXbp:setFontCompoundName( "8.Arial Bold" )

   oID              := XbpSLE():new( drawingArea, , {66,45}, {116,22} )
   oID:group        := XBP_BEGIN_GROUP    // ako je ukljuceno ne radi oDlg:keyboard
   oID:tabStop      := .T.
   oID:bufferLength := 10 // dDatum1 // Len( DTOC(dDatum1) )
   oID:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_F1,  Uputstvo_xDatum(cHlpTxt,oID), NIL ) }  // (F1) ZA HELP SAMO IZ POLJA ZA UPIS
   oID:create()
   oID:setData(dt1)
   oID:setFontCompoundName( FONT_COURIER_MEDIUM + FONT_STYLE_BOLD )


   oXbp             := XbpPushButton():new( drawingArea, , {10,11}, {60,25} )
   oXbp:caption     := "OK"   // izlaz sa prihvatanjem izmenjenog podatka
   oXbp:tabStop     := .T.
   oXbp:preselect   := .T.
   oXbp:group       := XBP_WITHIN_GROUP
   oXbp:activate    := {|| dDatum := Izlaz_sa_OK(dDatum1,oID,lKontrola), lExit := .T. } // IZLAZ SA IZMENOM
   oXbp:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_RETURN,; // (RETURN) ZA START DUGMETA SAMO IZ DUGMETA
                                     PostAppEvent( xbeP_Activate,,, obj ), NIL ) }
   oXbp:create()
   oXbp:setpointer(nil,2)

   oXbp             := XbpPushButton():new( drawingArea, , {72,11}, {60,25} )
   oXbp:caption     := "Brii"
   oXbp:tabStop     := .T.
   oXbp:preselect   := .T.
   oXbp:group       := XBP_WITHIN_GROUP
   oXbp:activate    := {|| oID:clear(), SetAppFocus(oID),tone(500,1) }
   oXbp:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_RETURN, PostAppEvent( xbeP_Activate,,, obj ), NIL ) } // (RETURN) ZA START DUGMETA SAMO IZ DUGMETA
   oXbp:create()
   oXbp:setpointer(nil,2)

   oXbp             := XbpPushButton():new( drawingArea, , {153,11}, {30,25} )
   oXbp:caption     := "?"
   oXbp:tabStop     := .T.
   oXbp:preselect   := .T.
   oXbp:group       := XBP_END_GROUP
   oXbp:activate    := {|| Uputstvo_xDatum(cHlpTxt,oXbp) }
   oXbp:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_RETURN, PostAppEvent( xbeP_Activate,,, obj ), NIL ) } // (RETURN) ZA START DUGMETA SAMO IZ DUGMETA
   oXbp:create()
   oXbp:setpointer(nil,2)

   oXbp:setFontCompoundName( FONT_COURIER_MEDIUM + FONT_STYLE_BOLD )

   oDlg:show()
  /*
   * This makes the login window modal
   */
   //SetAppWindow():disable() // prozor:disable()
   SetAppFocus( oID )

   lExit := .F.
   DO WHILE ! lExit
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO


   //SetAppWindow():enable() // prozor:enable()
   oDlg:destroy()

  /*
   * Clean up event queue
   */
   CLEAR TYPEAHEAD


 ************************************************************************************
 *   dDatum :=  ddatum1       - inicijalno postavljen na startu na ulazni datum, ili
 *   dDatum := izlaz_sa_OK()  - ucitan iz polja za upis datuma, kao izmenjen datum
 ************************************************************************************


                // ako se datum dobija iz funkcije Kontrola_Datuma()
RETURN(dDatum)  // ako je datum nedozvoljen vrati primljeni neizmenjeni datum
                // ako je datum dozvoljen vrati novoupisani datum




*****************************************************************************************************
STATIC FUNCTION izlaz_sa_OK(dDatum1, oID, lKontrola)          // izlaz sa izmenom
*****************************************************************************************************
 // primljeni postojeci datum = ddatum1
 // novi upisani datum = dDatum
LOCAL dDatum := CTOD(AllTrim( Upper( oID:getData() ) )) // ucitavanje datuma iz polja za upis

   IF lKontrola = .T.               // Kad je ukljucena kontrola datuma
   IF Kontrola_Datuma(dDatum) = .F. // prema podacima iz XCoba.SYS: Godina_Rada, Godina_Stop, Datumi_Stop
      dDatum := dDatum1             // ako je novoupisani datum nedozvoljen, vrati primljeni datum
   ENDIF                            // ako je novoupisani datum dozvoljen vrati taj datum
   ENDIF

RETURN(dDatum)


*****************************************************************************************************
STATIC FUNCTION Uputstvo_xDatum(cHlpTxt,oXbp)
*****************************************************************************************************
ConfirmBox(,cHlpTxt,"Uputstvo za rad",XBPMB_OK)
SetAppFocus(oXbp)
tone(500,1)
RETURN(nil)


* ( 18-06-2006 )
*******************************************************************************************************
FUNCTION Kontrola_Datuma(DT)
*******************************************************************************************************
/*
// PRIMER ZA UPOTREBU:
// KONTROLA DATUMA IZ MASKE ZA UPIS DATUMA:
FUNCTION xDatum( dDatum1, cNaslov, lKontrola, prozor )    // prozor := setAppWindow()
// primljeni datum u masku za izmenu - u funkciju, kao parametar, je: dDatum1
// izmenjeni datum u masci za izmenu - u funkciji, kao rezultat,  je: dDatum
  DEFAULT dDatum1 TO CTOD("  .  .    ") // primljeni datum
  dDatum := DATE()                      // izmenjen datum
  IF lKontrola = .T.                    // Kad je ukljucena kontrola datuma
  IF Kontrola_Datuma(dDatum) = .F.      // prema podacima iz XCoba.SYS: Godina_Rada, Godina_Stop, Datumi_Stop
      dDatum := dDatum1                 // ako je datum nedozvoljen, vrati primljeni datum
   ENDIF                                // ako je datum dozvoljen vrati izmenjeni datum
   ENDIF
 RETURN(dDatum)
*/

 LOCAL ;
 Godina_Stop := 2100                   ,;
 Datumi_Stop := CTOD("01.01.2100")     ,;
 Godina_Rada := 2100


       GD := YEAR(DT)
    *  IF GD > Godina_Stop
    *     tone(600,1)
    *     MsgBox("Nije dozvoljena godina veca od "+str(godina_stop,4,0),"STOP GODINA LICENCE - "+DTOC(DT))
    *  RETURN(.F.)
    *  ENDIF

      IF DT > Datumi_Stop
         tone(600,1)
         MsgBox("Nije dozvoljen datum veci od "+dtoc(Datumi_stop),"STOP DATUM REGISTRACIJE - "+DTOC(DT))
      RETURN(.F.)
      ENDIF

      IF GD <> Godina_Rada
         tone(600,1)
         MsgBox("Ispravni su samo datumi iz "+str(Godina_Rada),"STOP GODINA RADA - "+DTOC(DT))
         RETURN(.F.)
      ENDIF

RETURN(.T.)
